<template>
    <div class="login-box">
        <div class="login-logo">
             <div><img src="/img/logo.png"/></div>
        </div>
        <div class="card">
            <div class="card-body login-card-body">
                <div class="alert alert-danger"  v-if="error">
                    <strong>{{ error }}</strong>
                </div>
                <p class="login-box-msg">You are only one step a way from your new password, recover your password now.</p>
                <form>
                    <input type="hidden" name="token" v-bind:value="token"/>
                    <div class="form-group">
                        <label for="email">E-mail</label>
                        <div class="input-group mb-3">
                            <input id="email" type="email" class="form-control" name="email" 
                                   v-model="email" required autofocus
                                   v-bind:class="{ 'is-invalid': errors.email }">
                            <div class="input-group-append">
                                <div class="input-group-text">
                                    <span class="fas fa-envelope"></span>
                                </div>
                            </div>
                            <span class="invalid-feedback" role="alert" v-if="errors.email !== null">
                                <strong v-for="msg in errors.email">{{ msg }}</strong>
                            </span>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="password">Password</label>
                        <div class="input-group mb-3">
                            <input id="password" type="password" class="form-control" name="password" 
                                   v-model="password" required
                                   v-bind:class="{ 'is-invalid': errors.password }">
                            <div class="input-group-append">
                                <div class="input-group-text">
                                    <span class="fas fa-lock"></span>
                                </div>
                            </div>
                            <span class="invalid-feedback" role="alert" v-if="errors.password !== null">
                                <strong v-for="msg in errors.password">{{ msg }}</strong>
                            </span>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="password-confirm">Confirm password</label>
                        <div class="input-group mb-3">
                            <input id="password-confirm" type="password" class="form-control" 
                                   name="password_confirmation" v-model="password_confirmation" required
                                   v-bind:class="{ 'is-invalid': errors.password_confirmation }">
                            <div class="input-group-append">
                                <div class="input-group-text">
                                    <span class="fas fa-lock"></span>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <button type="submit" class="btn btn-primary btn-block" v-on:click.prevent="resetPassword">
                                Change password
                            </button>
                        </div>
                    </div>
                </form>
                <p class="mt-3 mb-1">
                    <router-link to="/login">Login</router-link>
                </p>
            </div>
        </div>
    </div>
</template>

<script>
import FormMixin from '../../mixins/FormMixin.vue';
import settings from '../../settings.js';

export default {
    mixins: [FormMixin],
    data() {
        return {
            token: this.$route.params.token,
            email: this.$route.query.email,
            password: null,
            password_confirmation: null,
            error: null,
            errors: {
                email: null,
                password: null
            }
        };
    },
    created() {
        $('body').addClass('login-page');
    },
    methods: {
        resetPassword() {
            if (!this.isValidForm()) {
                return;
            }
            var vm = this;
            var data = {
                token: this.token,
                email: this.email,
                password: this.password,
                password_confirmation: this.password_confirmation
            };
            var onSuccess = function(response) {
                if (response.data.redirectTo === '/login' || response.data.redirectTo === 'login') {
                    vm.$router.push({ name: 'login' });
                } else {
                    setTimeout(function() {
                        location.href = response.data.redirectTo;
                    }, 2000);
                }
            };
            var onError = function(error) {
                vm.error = error.response.data.message;
            };
            this.save('post', '/password/reset', data, {
                onSuccess,
                onError
            });
        }
    },
    mounted() {
        document.head.querySelector('title').text = "Reset password" + " - " + settings.title;
    }
};
</script>
